# NWidgetServerListHeader Class Reference

Full blown container to make it behave exactly as we want :). More...

Inheritance diagram for NWidgetServerListHeader:

## Public Member Functions
void | SetupSmallestSize (Window *w, bool init_array)
| Compute smallest size needed by the widget.
void | AssignSizePosition (SizingType sizing, uint x, uint y, uint given_width, uint given_height, bool rtl)
| Assign size and position to the widget.
void | Draw (const Window *w)
| Draw the widgets of the tree.
NWidgetCore * | GetWidgetFromPos (int x, int y)
| Retrieve a widget by its position.
bool | IsWidgetVisible (NetworkGameWindowWidgets widget) const
| Checks whether the given widget is actually visible.
## Private Attributes
bool | visible [6]
| The visible headers.
## Static Private Attributes
static const uint | MINIMUM_NAME_WIDTH_BEFORE_NEW_HEADER = 150
| Minimum width before adding a new header.

## Detailed Description

Full blown container to make it behave exactly as we want :).

Definition at line 116 of file network_gui.cpp.

## Member Function Documentation

void NWidgetServerListHeader::AssignSizePosition | ( | SizingType | sizing,
|  | uint | x,
|  | uint | y,
|  | uint | given_width,
|  | uint | given_height,
|  | bool | rtl |
| ) |  |  | `[inline, virtual]`

Assign size and position to the widget.

Parameters:

  | sizing | Type of resizing to perform.
  | x | Horizontal offset of the widget relative to the left edge of the window.
  | y | Vertical offset of the widget relative to the top edge of the window.
  | given_width | Width allocated to the widget.
  | given_height | Height allocated to the widget.
  | rtl | Adapt for right-to-left languages (position contents of horizontal containers backwards).

Afterwards, pos_x and pos_y contain the top-left position of the widget, smallest_x and smallest_y contain the smallest size such that all widgets of the window are consistent, and current_x and current_y contain the current size.

Implements NWidgetBase.

Definition at line 167 of file network_gui.cpp.

References NWidgetBase::AssignSizePosition(), NWidgetBase::current_x, NWidgetBase::current_y, NWidgetContainer::head, lengthof, MINIMUM_NAME_WIDTH_BEFORE_NEW_HEADER, NWidgetBase::next, NWidgetBase::pos_x, NWidgetBase::pos_y, NWidgetBase::prev, NWidgetBase::smallest_x, NWidgetBase::smallest_y, NWidgetContainer::tail, and visible.

void NWidgetServerListHeader::Draw | ( | const Window * | w | ) | `[inline, virtual]`

Draw the widgets of the tree.

The function calls Window::DrawWidget for each widget with a non-negative index, after the widget itself is painted.

Parameters:

  | w | Window that owns the tree.

Implements NWidgetBase.

Definition at line 207 of file network_gui.cpp.

References NWidgetContainer::head, NWidgetBase::next, and visible.

NWidgetCore* NWidgetServerListHeader::GetWidgetFromPos | ( | int | x,
|  | int | y |
| ) |  |  | `[inline, virtual]`

Retrieve a widget by its position.

Parameters:

  | x | Horizontal position relative to the left edge of the window.
  | y | Vertical position relative to the top edge of the window.

Returns:
  Returns the deepest nested widget that covers the given position, or `NULL` if no widget can be found.

Implements NWidgetBase.

Definition at line 217 of file network_gui.cpp.

References NWidgetBase::current_x, NWidgetBase::current_y, NWidgetCore::GetWidgetFromPos(), NWidgetContainer::head, IsInsideBS(), NWidgetBase::next, NWidgetBase::pos_x, NWidgetBase::pos_y, and visible.

bool NWidgetServerListHeader::IsWidgetVisible | ( | NetworkGameWindowWidgets | widget | ) | const`[inline]`

Checks whether the given widget is actually visible.

Parameters:

  | widget | the widget to check for visibility

Returns:
  true iff the widget is visible.

Definition at line 235 of file network_gui.cpp.

References lengthof, NGWW_NAME, and visible.

Referenced by NetworkGameWindow::DrawServerLine().

void NWidgetServerListHeader::SetupSmallestSize | ( | Window * | w,
|  | bool | init_array |
| ) |  |  | `[inline, virtual]`

Compute smallest size needed by the widget.

The smallest size of a widget is the smallest size that a widget needs to display itself properly. In addition, filling and resizing of the widget are computed. The function calls Window::UpdateWidgetSize for each leaf widget and background widget without child with a non-negative index.

Parameters:

  | w | Window owning the widget.
  | init_array | Initialize the `w->nested_array`.

Note:
  After the computation, the results can be queried by accessing the smallest_x and smallest_y data members of the widget.

Implements NWidgetBase.

Definition at line 142 of file network_gui.cpp.

References NWidgetBase::fill_x, NWidgetBase::fill_y, NWidgetContainer::head, max(), Window::nested_array, NWidgetBase::next, NGWW_HEADER, NWidgetBase::resize_x, NWidgetBase::resize_y, NWidgetBase::smallest_x, NWidgetBase::smallest_y, and NWidgetContainer::tail.

The documentation for this class was generated from the following file:

- src/network/network_gui.cpp